// IMPROVE: merge with constants.rs in seeder repo

// Source: https://www.svb.nl/nl/kindernamen/namen/meisjes-populariteit. IMPROVE: add number of occurrences per name, also below. IMPROVE: also look at historical names instead of recently popular names
#[rustfmt::skip]
pub const FIRST_NAMES_FEMALE: &[&str] = &[
    "Emma", "Julia", "Sophie", "Tess", "Mila", "Anna", "Zoë", "Sara", "Eva",
    "Evi", "Lotte", "Saar", "Nora", "Olivia", "Liv", "Lieke", "Noor", "Yara",
    "Lynn", "Fenna", "Fleur", "Isa", "Sarah", "Maud", "Lisa", "Milou", "Nina",
    "Roos", "Elin", "Noa", "Lauren", "Nova", "Sofie", "Emily", "Loïs", "Lina",
    "Esmee", "Jasmijn", "Amy", "Luna", "Sanne", "Hannah", "Ella", "Feline",
    "Sofia", "Julie", "Sophia", "Fien", "Maria", "Femke", "Vera", "Anne",
    "Naomi", "Liz", "Isabella", "Mia", "Lara", "Bo", "Lena", "Elise", "Hailey",
    "Amber", "Floor", "Charlotte", "Lizzy", "Norah", "Suze", "Jill", "Elena",
    "Fenne", "Veerle", "Isabel", "Eline", "Iris", "Ivy", "Benthe", "Rosa",
    "Cato", "Tessa", "Puck", "Evy", "Linde", "Fay", "Lize", "Rosalie", "Hanna",
    "Lana", "Livia", "Laura", "Lola", "Merel", "Lily", "Elif", "Kiki", "Fiene",
    "Nikki", "Johanna", "Juul", "Suus", "Romy", "Noah",
];

// Source: https://www.svb.nl/nl/kindernamen/namen/jongens-populariteit
#[rustfmt::skip]
pub const FIRST_NAMES_MALE: &[&str] = &[
    "Lucas", "Daan", "Sem", "Levi", "Finn", "Milan", "Luuk", "Bram", "Liam",
    "Jesse", "Mees", "Sam", "Thomas", "Max", "Thijs", "Adam", "Julian", "Luca",
    "Noud", "Lars", "Benjamin", "James", "Ruben", "Siem", "Gijs", "Jayden",
    "Teun", "Stijn", "Tim", "Mats", "Hugo", "Boaz", "Mason", "Jan", "Jens",
    "Olivier", "Sven", "David", "Dex", "Guus", "Vince", "Floris", "Jack",
    "Tijn", "Ryan", "Joep", "Ties", "Cas", "Tygo", "Jurre", "Daniël", "Tom",
    "Willem", "Pepijn", "Roan", "Morris", "Fedde", "Jason", "Tobias", "Owen",
    "Pim", "Dean", "Mohammed", "Xavi", "Abel", "Mohamed", "Senn", "Dani",
    "Rayan", "Quinn", "Nathan", "Mick", "Hidde", "Samuel", "Alexander", "Niek",
    "Aiden", "Stan", "Johannes", "Dylan", "Kai", "Joshua", "Thijmen", "Boris",
    "Jace", "Job", "Pieter", "Otis", "Casper", "Sepp", "Zayn", "Joris", "Jake",
    "Jelle", "Jip", "Lenn", "Koen", "Jax", "Jasper",
];

// Source: https://www.babynamen.nl/namen/unisex/#h-de-100-populairste-unisex-namen
#[rustfmt::skip]
pub const FIRST_NAMES_X: &[&str] = &[
    "Noah", "Luca", "Sem", "Sam", "Isa", "Nova", "Bo", "Jip", "Lou",
    "Charlie", "Kai", "Noé", "Jayden", "Dani", "Lio", "Roan", "Lenn", "Melle",
    "Ezra", "Quinn", "Bowie", "Puck", "Robin", "Novi", "Beau", "Bodhi",
    "Riley", "Senna", "Logan", "Marley", "Demi", "Mace", "Luka", "Lowen",
    "Jules", "Alex", "Anne", "Joa", "Bobby", "Jackie", "Noël", "Bodi", "Jamie",
    "Ali", "Kay", "Lío", "Miran", "Lux", "Zoey", "Indy", "Bobbi", "Coco",
    "Nouri", "Eden", "Izzy", "Vesper", "Gabriel", "Juda", "Marly", "Micha",
    "Eli", "Riv", "Teddy", "Joey", "Manu", "Sami", "Jaydi", "Nour", "Diede",
    "Nowi", "Sil", "Sammie", "Jaimy", "Louie", "Jona", "Silke", "Doris",
    "Lennon", "Chris", "Noï", "Joes", "Loet", "Jessie", "Louèn", "Len",
    "Marijn", "Jule", "Maan", "Arya", "Bobbie", "Maxime", "Lenny", "Antoni",
    "Kae", "Revi", "Royce", "Billie", "Eef", "Puk", "Scottie",
];

// Family names including prefixes. Source: https://nl.wikipedia.org/wiki/Lijst_van_meest_voorkomende_achternamen_van_Nederland (original source: https://cbgfamilienamen.nl/nfb/documenten/top100.pdf). IMPROVE: add number of occurrences per name and use this for random name selection
pub const FAMILY_NAMES: &[(&str, &str, u32)] = &[
    // Note: structure is: (voorvoegsel, familienaam, number of occurrences)
    ("de", "Jong", 86_534),
    ("", "Jansen", 75_698),
    ("de", "Vries", 73_152),
    ("van de", "Berg", 60_135 / 3),
    ("van den", "Berg", 60_135 / 3),
    ("van der", "Berg", 60_135 / 3),
    ("van", "Dijk", 57_879),
    ("", "Bakker", 56_864),
    ("", "Janssen", 55_394),
    ("", "Visser", 50_929),
    ("", "Smit", 43_498),
    ("", "Meijer", 41_497 / 2),
    ("", "Meyer", 41_497 / 2),
    ("de", "Boer", 39_575),
    ("", "Mulder", 37_250),
    ("de", "Groot", 37_221),
    ("", "Bos", 36_479),
    ("", "Vos", 31_154),
    ("", "Peters", 30_864),
    ("", "Hendriks", 30_199),
    ("van", "Leeuwen", 28_774),
    ("", "Dekker", 28_682),
    ("", "Brouwer", 26_224),
    ("de", "Wit", 24_904),
    ("", "Dijkstra", 24_175),
    ("", "Smits", 23_816),
    ("de", "Graaf", 21_699),
    ("van der", "Meer", 21_354 / 2),
    ("van de", "Meer", 21_354 / 2),
    ("van der", "Linden", 20_835),
    ("", "Kok", 20_834),
    ("", "Jacobs", 20_822),
    ("de", "Haan", 20_707),
    ("", "Vermeulen", 20_633),
    ("van den", "Heuvel", 20_583),
    ("van der", "Veen", 19_847 / 2),
    ("van de", "Veen", 19_847 / 2),
    ("van den", "Broek", 18_998),
    ("de", "Bruijn", 18_218 / 2),
    ("de", "Bruyn", 18_218 / 2),
    ("de", "Bruin", 18_105),
    ("van der", "Heijden", 17_645 / 2),
    ("van der", "Heyden", 17_645 / 2),
    ("", "Schouten", 17_626),
    ("van", "Beek", 17_148),
    ("", "Willems", 17_042),
    ("van", "Vliet", 16_903),
    ("van de", "Ven", 16_282 / 2),
    ("van der", "Ven", 16_282 / 2),
    ("", "Hoekstra", 16_114),
    ("", "Maas", 16_070),
    ("", "Verhoeven", 15_902),
    ("", "Koster", 15_898),
    ("van", "Dam", 15_729),
    ("van der", "Wal", 15_646 / 2),
    ("van de", "Wal", 15_646 / 2),
    ("", "Prins", 15_361),
    ("", "Blom", 15_097),
    ("", "Huisman", 15_043),
    ("", "Peeters", 14_474),
    ("de", "Jonge", 14_379),
    ("", "Kuipers", 14_362),
    ("van", "Veen", 14_199),
    ("", "Post", 13_965),
    ("", "Kuiper", 13_803),
    ("", "Veenstra", 13_626),
    ("", "Kramer", 13_490),
    ("van den", "Brink", 13_459 / 2),
    ("van de", "Brink", 13_459 / 2),
    ("", "Scholten", 13_129),
    ("van", "Wijk", 13_053),
    ("", "Postma", 12_886),
    ("", "Martens", 12_592),
    ("", "Vink", 12_453),
    ("de", "Ruiter", 12_297),
    ("", "Timmermans", 12_063),
    ("", "Groen", 11_967),
    ("", "Gerritsen", 11_861),
    ("", "Jonker", 11_789),
    ("van", "Loon", 11_774),
    ("", "Boer", 11_697),
    ("van der", "Velde", 11_654 / 3),
    ("van den", "Velde", 11_654 / 3),
    ("van de", "Velde", 11_654 / 3),
    ("", "Willemsen", 11_528),
    ("", "Smeets", 11_502),
    ("de", "Lange", 11_321),
    ("de", "Vos", 11_304),
    ("", "Bosch", 11_229),
    ("van", "Dongen", 11_123),
    ("", "Schipper", 11_088),
    ("de", "Koning", 11_046),
    ("van der", "Laan", 11_002),
    ("", "Koning", 10_957),
    ("van der", "Velden", 10_918 / 3),
    ("van de", "Velden", 10_918 / 3),
    ("van den", "Velden", 10_918 / 3),
    ("", "Driessen", 10_780),
    ("van", "Doorn", 10_775),
    ("", "Hermans", 10_641),
    ("", "Evers", 10_578),
    ("van den", "Bosch", 10_491),
    ("van der", "Meulen", 10_320),
    ("", "Hofman", 10_271),
    ("", "Bosman", 10_246),
    ("", "Wolters", 10_241),
    ("", "Sanders", 10_208),
    ("van der", "Horst", 10_203),
    ("", "Mol", 10_203),
    ("", "Kuijpers", 10_188 / 2),
    ("", "Kuypers", 10_188 / 2),
    ("", "Molenaar", 10_175),
    ("van de", "Pol", 10_128 / 3),
    ("van den", "Pol", 10_128 / 3),
    ("van der", "Pol", 10_128 / 3),
    ("de", "Leeuw", 10_101),
    ("", "Verbeek", 9_775),
    // Turkish family names. Source: https://www.turks.nl/turkije/algemeen/dit-zijn-de-meest-voorkomende-turkse-namen-en-achternamen in combination with https://www.cbgfamilienamen.nl/nfb/lijst_namen.php?operator=eq&naam=...
    ("", "Kaya", 3109),
    ("", "Yildiz", 2711),
    ("", "Yildirim", 2567),
    ("", "Demir", 2395),
    ("", "Sahin", 2327),
    ("", "Öztürk", 2437),
    ("", "Özdemir", 2091),
    ("", "Aydin", 2199),
    ("", "Çelik", 1908),
    ("", "Arslan", 1650),
    // Surinamese family names. Source: https://nl.wikipedia.org/wiki/Lijst_van_meest_voorkomende_achternamen_van_Suriname in combination with https://www.cbgfamilienamen.nl/nfb/lijst_namen.php?operator=eq&naam=...
    ("", "Singh", 2250),
    ("", "Chen", 1934),
    ("", "Li", 1445),
    ("", "Pinas", 1286),
    ("", "Liu", 1097),
    ("", "Lin", 1013),
    ("", "Zhang", 730),
    ("", "Mohan", 549),
    ("Da", "Silva", 353),
    ("", "Tjon", 336),
    // Moroccan family names. Source: https://www.cbgfamilienamen.nl/nfb/detail_naam.php?info=kenmerk&kenmerk=Marokkaanse+naam&nfd_naam=Loukili in combination with https://www.cbgfamilienamen.nl/nfb/lijst_namen.php?operator=eq&naam=...
    ("", "Loukili", 657),
    ("El", "Idrissi", 617),
    ("El", "Moussaoui", 619),
    ("", "Tahiri", 563),
    ("", "Benali", 522),
    ("", "Kasmi", 476),
    ("", "Ziani", 467),
    ("", "Talhaoui", 450),
    ("", "Salhi", 451),
    ("", "Daoudi", 422),
    // Less common names (edge cases because of their length). Source: https://nl.wikipedia.org/wiki/Lijst_van_langste_achternamen_van_Nederland
    ("van", "Oldenbarneveld genaamd Witte Tullingh", 29),
    ("van", "Hövell tot Westervlier en Wezeveld", 32),
    ("van", "Hövell van Wezeveld en Westerflier", 42),
    ("", "Oetgens van Waveren Pancras Clifford", 44),
    ("", "Ebbelinghaus ook wel genaamd Wirxel", 27),
];
